#pragma once
#include "O2JamMusic.hpp"
#include "O2JamNote.hpp"
#include "SoundRanking.hpp"
//08/4/20 1.05----->
#include "DifficultyTypes.hpp"
//<-----------------

namespace Lmt {
namespace O2Bms {
	class BmsConverter {
	public:
		struct FromO2Jam {
			wstring inputEasyNote;
			wstring inputNormalNote;
			wstring inputHardNote;
			wstring outputDir;
			int maxLevel;
			//2007/5/20 1.02----->
			int maxLevelO2;
			//<-------------------
			int judgeRank;
			int format;
			int dummySoundIndex;
			int bgmCount;
			int maxSoundCount;
			const SoundRanking *psoundRanking;
			//2007/2/24 1.01----->
			bool nothingLongNote;
			//<-------------------
			//08/4/20 1.05----->
			DifficultyTypes diffType;
			//<-----------------
			//-----ȉAo͗p-----
			int notFoundSoundCount;
			int outOfRankSoundCount;
		};
	private:
		struct O2JamNoteHeader {
			int measure;
			short channel;
			short count;
		};
	public:
		static const int MinLevel = 1;
		//2007/5/20 1.02----->
//		static const int MaxLevel = 50;
		static const int MaxLevel = 99;
		//<-------------------
	public:
		bool Convert( FromO2Jam &desc, const O2JamMusic &m ) const;
	private:
		static wstring O2BuildFileName( const wstring &title, const wstring &difficulty );
		static bool O2BuildNote( const wstring &path, O2JamNote &note );
		//2007/2/24 1.01----->
//		static void O2AddBmsHeader( wstringstream &ss, const O2JamMusicDesc &desc, int level, int judgeRank, const wstring &difficulty );
		static void O2AddBmsHeader( wstringstream &ss, const O2JamMusicDesc &desc, int level, int judgeRank, int totalGroove, const wstring &difficulty );
		//<-------------------
		static void O2AddBmsSounds( wstringstream &ss, const FromO2Jam &o2 );
		static void O2AddBmsTempos( wstringstream &ss, const O2JamNote &note );
		//2007/2/24 1.01----->
//		static void O2AddBmsNote( wstringstream &ss, const O2JamNote &note, FromO2Jam &o2 );
		static void O2AddBmsNote( wstringstream &ss, const O2JamNote &note, FromO2Jam &o2, int &keyCount );
		//<-------------------
		static void O2AddBmsNoteBpm( wstringstream &ss, const O2JamNote &note, FromO2Jam &o2, int measure );
		//2007/2/24 1.01----->
//		static void O2AddBmsNotePlayable( wstringstream &ss, const O2JamNote &note, FromO2Jam &o2, int measure );
		//08/4/20 1.05----->
//		static void O2AddBmsNotePlayable( wstringstream &ss, const O2JamNote &note, FromO2Jam &o2, int measure, int &keyCount );
		static void O2AddBmsNotePlayable( wstringstream &ss, const O2JamNote &note, FromO2Jam &o2, int measure, bool *lnHolds, int &keyCount );
		//<-----------------
		//<-----------------
		//<-------------------
		static void O2AddBmsNoteBackground( wstringstream &ss, const O2JamNote &note, FromO2Jam &o2, int measure );
		static wstring O2MakeNoteDef( int measure, int channel );
		//2007/2/24 1.01----->
		static int O2CalculateTotalGroove( int keyCount );
		//<-------------------
		//08/4/20 1.05----->
	private:
		static const wchar_t *m_difficaltyO2[3];
		static const wchar_t *m_difficaltyIIDX[3];
		static const wchar_t *m_difficaltyNone[3];
		//<-----------------
	};
}
}
