#include "stdafx.h"
#include "resource.h"
#include "ConvertResult.hpp"
#include "Resource.hpp"

namespace Lmt {
namespace O2Bms {
	ConvertResult::ConvertResult() {
		m_result = Okay;
	}

	ConvertResult::ConvertResult( int result ) {
		m_result = result;
	}

	wstring ConvertResult::ToString() const {
		switch (m_result) {
			case Okay: return Resource::GetString( IDS_CVRES_OK );
			case Canceled: return Resource::GetString( IDS_CVRES_CANCEL );
			case FailedToOpenSource: return Resource::GetString( IDS_CVRES_FAILOPENOJN );
			case FailedToCreateOutDir: return Resource::GetString( IDS_CVRES_FAILCREOUTDIR );
			case FailedToConvertBms: return Resource::GetString( IDS_CVRES_FAILCONVBMS );
			case FailedToOpenSoundFile: return Resource::GetString( IDS_CVRES_FAILOPENOJM );
			case HaveAnySoundConvertError: return Resource::GetString( IDS_CVRES_CONVSOUNDERR );
			case AnySoundsReplacedDummy: return Resource::GetString( IDS_CVRES_REPDUMMY );
			case FailedToConvertSongImage: return Resource::GetString( IDS_CVRES_FAILCONVIMG );
			//2007/5/24 1.03----->
			case DirectoryAlreadyExists: return Resource::GetString( IDS_CVRES_DIREXISTS );
			//<-------------------
			default: return Resource::GetString( IDS_CVRES_UNKNOWN );
		}
	}

	bool ConvertResult::operator ==( int result ) const {
		return m_result == result;
	}

	bool ConvertResult::operator !=( int result ) const {
		return m_result != result;
	}
}
}
