#pragma once
#include "ModalDialog.hpp"
#include "SoundFormat.hpp"
#include "WaveQualities.hpp"
#include "JudgeRanks.hpp"
#include "ConvertResult.hpp"
//2007/5/23 1.03----->
#include "ConvertTargetFile.hpp"
//<-------------------
//08/4/20 1.05----->
#include "DifficultyTypes.hpp"
//<-----------------

namespace Lmt {
namespace O2Bms {
	class ConvertingDialog : public ModalDialog {
		//2007/5/23 1.03----->
//		typedef vector<wstring> ConvertTargetArray;
		typedef vector<ConvertTargetFile> ConvertTargetArray;
		//<-------------------
		typedef vector<ConvertResult> ConvertResultArray;
		ConvertTargetArray m_targets;
		ConvertResultArray m_results;
		wstring m_outputDir;
		SoundFormat m_format;
		WaveQualities m_quality;
		//08/4/20 1.05----->
		DifficultyTypes m_diffType;
		//<-----------------
		int m_maxLevel;
		//2007/5/20 1.02----->
		int m_maxLevelO2;
		//<-------------------
		JudgeRanks m_judgeRank;
		bool m_outputEasy;
		bool m_outputNormal;
		bool m_outputHard;
		bool m_limitedSoundCount;
		//2007/2/24 1.01----->
		bool m_nothingLongNote;
		//<-------------------
		//2007/5/24 1.03----->
		bool m_dirExistsAbort;
		//<-------------------
	private:
		static const int StartConvertSign = (WM_USER + 1);
		static const int EndDialogSign = (WM_USER + 2);
		static const int UpdateProgressSign = (WM_USER + 3);
		static const int ShowInformationSign = (WM_USER + 4);
	private:
		HANDLE m_thread;
		bool m_isCancelConvert;
	public:
		ConvertingDialog();
		//2007/5/23 1.03----->
//		void AddTarget( const wstring &target );
		void AddTarget( const ConvertTargetFile &target );
		//<-------------------
		void SetOutputDir( const wstring &outputDir );
		void SetSoundFormat( SoundFormat format );
		void SetWaveQualitiy( WaveQualities quality );
		//08/4/20 1.05----->
		void SetDifficultyType( DifficultyTypes diffType );
		//<-----------------
		void SetMaxLevel( int maxLevel );
		//2007/5/20 1.02----->
		void SetO2MaxLevel( int maxLevel );
		//<-------------------
		void SetJudgeRank( JudgeRanks judgeRank );
		void SetOutputEasy( bool output );
		void SetOutputNormal( bool output );
		void SetOutputHard( bool output );
		void SetLimitedSoundCount( bool limitedSoundCount );
		//2007/2/24 1.01----->
		void SetNothingLongNote( bool nothingLongNote );
		//<-------------------
		//2007/5/24 1.03----->
		void SetDirExistsAbort( bool dirExistsAbort );
		//<-------------------
		int GetTargetCount() const;
		//2007/5/23 1.03----->
//		wstring GetTarget( int index ) const;
		ConvertTargetFile GetTarget( int index ) const;
		//<-------------------
		ConvertResult GetConvertResult( int index ) const;
	private:
		virtual bool DialogProc( UINT msg, WPARAM wp, LPARAM lp );
		virtual void OnInitDialog();
		virtual bool OnOk();
		virtual bool OnCancel();
		virtual bool OnCommand( WORD id, WORD code, HWND hwnd );
	private:
		void OnStartConvert();
		static DWORD WINAPI ConvertProc( LPVOID p );
	};
}
}
