#pragma once

namespace Lmt {
namespace O2Bms {
	class FileDialog {
		typedef vector<wstring> PathArray;
		PathArray m_files;
		HWND m_parent;
		wstring m_title;
		wstring m_initialDir;
		wstring m_initialFile;
		wstring m_filter;
		wstring m_filterNative;
		wstring m_defExt;
		bool m_multiSelect;
	public:
		FileDialog();
		int GetCount() const;
		wstring GetFileName( int index ) const;
		void SetParent( HWND parent );
		void SetTitle( const wstring &title );
		void SetInitialDir( const wstring &dir );
		void SetInitialFile( const wstring &file );
		void SetFilter( const wstring &filter );
		void SetDefaultExtension( const wstring &defExt );
		void SetMultiSelect( bool multiSelect );
		bool SelectOpen();
		bool SelectSave();
		void ClearFileBuffer();
	private:
		void BuildFilterNative();
	};
}
}
