#include "stdafx.h"
#include "ImageConverter.hpp"
#include "Utility.hpp"

namespace Lmt {
namespace O2Bms {
	ImageConverter::ImageConverter() {
		//(ͥ)
	}
	
	bool ImageConverter::Convert( const wstring &input, const wstring &output ) {
		static const int destWidth = 640;
		static const int destHeight = 480;
		static const int destBits = 24;
		static const int destLength = (destWidth * destHeight) * (destBits / 8);

		bool result = false;
		IPicture *psrc = NULL;
		IDispatch *pdispatch = NULL;
		_variant_t srcName = input.c_str();
		OLE_HANDLE srcHandle = NULL;;
		HBITMAP bmpSrc = NULL;
		HBITMAP bmpDest = NULL;
		HBITMAP bmpTempSrc = NULL;
		HBITMAP bmpTempDest = NULL;
		LPVOID bits = NULL;
		HRESULT hr;
		BITMAP bmSrcInfo;
		BITMAPINFO bi;
		BITMAPFILEHEADER bfh;
		HDC dcSrc = NULL;
		HDC dcDest = NULL;
		int srcW = 0;
		int srcH = 0;
		fstream fsOut;
		
		hr = ::OleLoadPictureFile( srcName, &pdispatch );
		if (FAILED( hr )) {
			goto EndMethod;
		}
		else {
			pdispatch->QueryInterface( IID_IPicture, reinterpret_cast<void**>( &psrc ) );
			pdispatch->Release();
			pdispatch = NULL;
//			psrc->get_Width( &srcW );
//			psrc->get_Height( &srcH );
		}
		
		memset( &bi, 0, sizeof(bi) );
		bi.bmiHeader.biSize = sizeof(bi.bmiHeader);
		bi.bmiHeader.biBitCount = destBits;
		bi.bmiHeader.biPlanes = 1;
		bi.bmiHeader.biWidth = destWidth;
		bi.bmiHeader.biHeight = destHeight;
		bmpDest = ::CreateDIBSection( NULL, &bi, DIB_RGB_COLORS, &bits, NULL, 0 );
		if (bmpDest == NULL) {
			goto EndMethod;
		}
		
//		if (psrc->get_CurDC( &dcSrc ) != S_OK) {
//			goto EndMethod;
//		}
		if ((dcSrc = ::CreateCompatibleDC( NULL )) == NULL) {
			goto EndMethod;
		}
		if ((dcDest = ::CreateCompatibleDC( NULL )) == NULL) {
			goto EndMethod;
		}

		if (FAILED( psrc->get_Handle( &srcHandle ) )) {
			goto EndMethod;
		}
		bmpSrc = reinterpret_cast<HBITMAP>( srcHandle );
		bmpTempSrc = reinterpret_cast<HBITMAP>( ::SelectObject( dcSrc, bmpSrc ) );
		bmpTempDest = reinterpret_cast<HBITMAP>( ::SelectObject( dcDest, bmpDest ) );

		::GetObject( bmpSrc, sizeof(bmSrcInfo), &bmSrcInfo );
		srcW = bmSrcInfo.bmWidth;
		srcH = bmSrcInfo.bmHeight;

		::SetStretchBltMode( dcSrc, HALFTONE );
		::SetStretchBltMode( dcDest, HALFTONE );
		
		if (::StretchBlt( dcDest, 0, 0, destWidth, destHeight, dcSrc, 0, 0, srcW, srcH, SRCCOPY ) == FALSE) {
			goto EndMethod;
		}
		
		fsOut.open( Utility::WStringToString( output ).c_str(), ios::out | ios::binary );
		if (fsOut.is_open() == false) {
			goto EndMethod;
		}
		
		bfh.bfType = 0x4d42;
		bfh.bfSize = sizeof(bfh) + sizeof(bi.bmiHeader) + destLength;
		bfh.bfReserved1 = 0;
		bfh.bfReserved2 = 0;
		bfh.bfOffBits = sizeof(bfh) + sizeof(bi.bmiHeader);
		fsOut.write( (char*)&bfh, sizeof(bfh) );
		if (fsOut.fail() == true) {
			goto EndMethod;
		}
		fsOut.write( (char*)&bi.bmiHeader, sizeof(bi.bmiHeader) );
		if (fsOut.fail() == true) {
			goto EndMethod;
		}
		fsOut.write( (char*)bits, destLength );
		if (fsOut.fail() == true) {
			goto EndMethod;
		}
		
		result = true;
		
	EndMethod:
		if (fsOut.is_open() == true) {
			fsOut.close();
		}
		if (bmpTempSrc != NULL) {
			::SelectObject( dcSrc, bmpTempSrc );
		}
		if (bmpTempDest != NULL) {
			::SelectObject( dcDest, bmpTempDest );
		}
		if (bmpDest != NULL) {
			::DeleteObject( bmpDest );
		}
		if (dcSrc != NULL) {
			::DeleteDC( dcSrc );
		}
		if (dcDest != NULL) {
			::DeleteDC( dcDest );
		}
		if (psrc != NULL) {
			psrc->Release();
		}
		return result;
	}
}
}
