#include "stdafx.h"
#include "MainDialog.hpp"
#include "Resource.hpp"
#include "Utility.hpp"
#include "ConvertingDialog.hpp"
#include "ResultDialog.hpp"
//2007/5/23 1.03----->
#include "ConvertTargetFile.hpp"
#include "O2JamMusic.hpp"
//<-------------------
//08/4/20 1.05----->
#include "DifficultyTypes.hpp"
//<-----------------

namespace Lmt {
namespace O2Bms {
	void MainDialog::OnInitDialog() {
		HWND hwnd;

		hwnd = this->GetItem( IDC_MAIN_BUTTON_DELETE );
		::EnableWindow( hwnd, FALSE );

		hwnd = this->GetItem( IDC_MAIN_COMBO_QUALITY );
		::SendMessage( hwnd, CB_ADDSTRING, 0, reinterpret_cast<LPARAM>( Resource::GetString( IDS_QUALITY_LOW ).c_str() ) );
		::SendMessage( hwnd, CB_ADDSTRING, 0, reinterpret_cast<LPARAM>( Resource::GetString( IDS_QUALITY_MID ).c_str() ) );
		::SendMessage( hwnd, CB_ADDSTRING, 0, reinterpret_cast<LPARAM>( Resource::GetString( IDS_QUALITY_HIGH ).c_str() ) );
		//2007/6/10 1.04----->
		::SendMessage( hwnd, CB_ADDSTRING, 0, reinterpret_cast<LPARAM>( Resource::GetString( IDS_QUALITY_ORG ).c_str() ) );
		//--->
//		::SendMessage( hwnd, CB_ADDSTRING, 0, reinterpret_cast<LPARAM>( Resource::GetString( IDS_QUALITY_OGGLOW ).c_str() ) );
		//<---------
		::SendMessage( hwnd, CB_ADDSTRING, 0, reinterpret_cast<LPARAM>( Resource::GetString( IDS_QUALITY_OGGMID ).c_str() ) );
		::SendMessage( hwnd, CB_ADDSTRING, 0, reinterpret_cast<LPARAM>( Resource::GetString( IDS_QUALITY_OGGHIGH ).c_str() ) );
		::SendMessage( hwnd, CB_ADDSTRING, 0, reinterpret_cast<LPARAM>( Resource::GetString( IDS_QUALITY_OGGORG ).c_str() ) );
//		::SendMessage( hwnd, CB_SETCURSEL, 1, 0 );
		::SendMessage( hwnd, CB_SETCURSEL, 3, 0 );
		//<-------------------

		//08/4/20 1.05----->
		hwnd = this->GetItem( IDC_MAIN_COMBO_DIFFICULTY );
		::SendMessage( hwnd, CB_ADDSTRING, 0, reinterpret_cast<LPARAM>( Resource::GetString( IDS_DIFFICULTY_O2JAM ).c_str() ) );
		::SendMessage( hwnd, CB_ADDSTRING, 0, reinterpret_cast<LPARAM>( Resource::GetString( IDS_DIFFICULTY_IIDX ).c_str() ) );
		::SendMessage( hwnd, CB_ADDSTRING, 0, reinterpret_cast<LPARAM>( Resource::GetString( IDS_DIFFICULTY_NONE ).c_str() ) );
		::SendMessage( hwnd, CB_SETCURSEL, 0, 0 );
		//ӁFڂ̏ԂDifficultyTypesƓ邱
		//<-----------------

		hwnd = this->GetItem( IDC_MAIN_EDIT_MAXLEVEL );
		//2007/5/20 1.02----->
//		::SendMessage( hwnd, EM_LIMITTEXT, 3, 0 );
		::SendMessage( hwnd, EM_LIMITTEXT, 2, 0 );
		//<-------------------
		//2007/6/10 1.04----->
//		::SetWindowText( hwnd, L"50" );
		::SetWindowText( hwnd, L"99" );
		//<-------------------

		//2007/5/20 1.02----->
		hwnd = this->GetItem( IDC_MAIN_EDIT_O2MAXLEVEL );
		::SendMessage( hwnd, EM_LIMITTEXT, 2, 0 );
		//2007/6/10 1.04----->
//		::SetWindowText( hwnd, L"50" );
		::SetWindowText( hwnd, L"99" );
		//<-------------------
		//<-------------------

		//2007/6/10 1.04----->
//		::CheckDlgButton( m_hwnd, IDC_MAIN_CHECK_WAVEOUT, BST_CHECKED );
		//<-------------------

		hwnd = this->GetItem( IDC_MAIN_COMBO_JUDGE );
		::SendMessage( hwnd, CB_ADDSTRING, 0, reinterpret_cast<LPARAM>( Resource::GetString( IDS_JUDGE_EASY ).c_str() ) );
		::SendMessage( hwnd, CB_ADDSTRING, 0, reinterpret_cast<LPARAM>( Resource::GetString( IDS_JUDGE_NORMAL ).c_str() ) );
		::SendMessage( hwnd, CB_ADDSTRING, 0, reinterpret_cast<LPARAM>( Resource::GetString( IDS_JUDGE_HARD ).c_str() ) );
		::SendMessage( hwnd, CB_ADDSTRING, 0, reinterpret_cast<LPARAM>( Resource::GetString( IDS_JUDGE_VHARD ).c_str() ) );
		//2007/6/10 1.04----->
//		::SendMessage( hwnd, CB_SETCURSEL, 1, 0 );
		::SendMessage( hwnd, CB_SETCURSEL, 0, 0 );
		//<-------------------

		::CheckDlgButton( m_hwnd, IDC_MAIN_CHECK_EASY, BST_CHECKED );
		::CheckDlgButton( m_hwnd, IDC_MAIN_CHECK_NORMAL, BST_CHECKED );
		::CheckDlgButton( m_hwnd, IDC_MAIN_CHECK_HARD, BST_CHECKED );

		hwnd = this->GetItem( IDC_MAIN_BUTTON_START );
		::EnableWindow( hwnd, FALSE );

		m_fileDlg.SetParent( m_hwnd );
		m_fileDlg.SetTitle( Resource::GetString( IDS_OPNDLG_TITLE ) );
		m_fileDlg.SetInitialDir( Utility::CombinePath( Utility::GetProgramFilesDirectory(), Resource::GetString( IDS_OPNDLG_INITIALDIR ) ) );
		m_fileDlg.SetInitialFile( Resource::GetString( IDS_OPNDLG_INITIALFILE ) );
		m_fileDlg.SetFilter( Resource::GetString( IDS_OPNDLG_FILTER ) );
		m_fileDlg.SetDefaultExtension( Resource::GetString( IDS_OPNDLG_DEFEXT ) );
		m_fileDlg.SetMultiSelect( true );

		m_dirDlg.SetParent( m_hwnd );
		m_dirDlg.SetTitle( Resource::GetString( IDS_DIRDLG_TITLE ) );
		m_dirDlg.SetInitialDir( Utility::GetCurrentDirectory() );

		//2007/6/10 1.04----->
		HFONT hfont;
		LOGFONT lf;

		 hfont = (HFONT)::GetStockObject( DEFAULT_GUI_FONT );
		::GetObject( hfont, sizeof(lf), &lf );
		lf.lfWeight = FW_BOLD;
		m_hfontOfficial = ::CreateFontIndirect( &lf );
		::SendMessage( this->GetItem( IDC_MAIN_STATIC_OFFICIAL ), WM_SETFONT, (WPARAM)m_hfontOfficial, MAKEWORD( TRUE, 0 ) );
		//<-------------------

		//2007/6/10 1.04----->
		this->OnUpdateOfficialRule();
		//<-------------------
	}

	bool MainDialog::OnOk() {
		return false;
	}

	bool MainDialog::OnCancel() {
		return true;
	}

	bool MainDialog::OnCommand( WORD id, WORD code, HWND hwnd ) {
		switch (id) {
			case IDC_MAIN_BUTTON_ADD:
				this->OnAddTarget();
				break;
			case IDC_MAIN_BUTTON_DELETE:
				this->OnDeleteTarget();
				break;
			case IDC_MAIN_BUTTON_SELDIR:
				this->OnSelectOutDir();
				break;
			//2007/6/10 1.04----->
//			case IDC_MAIN_CHECK_WAVEOUT:
//				this->OnCheckDecodeWav();
//				break;
			//<-------------------
			case IDC_MAIN_BUTTON_START:
				this->OnStartConvert();
				break;
			//2007/6/10 1.04----->
			case IDC_MAIN_EDIT_MAXLEVEL:
			case IDC_MAIN_EDIT_O2MAXLEVEL:
				if (code != EN_KILLFOCUS) {
					return false;
				}
				else {
					this->OnUpdateOfficialRule();
					return true;
				}
			case IDC_MAIN_COMBO_JUDGE:
			//08/4/20 1.05----->
			case IDC_MAIN_COMBO_DIFFICULTY:
			//<-----------------
				if (code != CBN_SELCHANGE) {
					return false;
				}
				else {
					this->OnUpdateOfficialRule();
					return true;
				}
			case IDC_MAIN_CHECK_LN2NN:
				if (code != BN_CLICKED) {
					return false;
				}
				else {
					this->OnUpdateOfficialRule();
					return true;
				}
			//<-------------------
			default:
				return false;
		}
		return true;
	}

	void MainDialog::OnAddTarget() {
		if (m_fileDlg.SelectOpen() == false) {
			return;
		}

		//2007/5/23 1.03----->
		ConvertTargetFile *ptarget = NULL;
		O2JamMusic musicTemp;
		wstring path;
		LRESULT result;
		//<-------------------
		HWND hwnd = this->GetItem( IDC_MAIN_LIST );
		int i, count = m_fileDlg.GetCount();

		for (i = 0; i < count; i++) {
			//2007/5/23 1.03----->
//			::SendMessage( hwnd, LB_ADDSTRING, 0, reinterpret_cast<LPARAM>( m_fileDlg.GetFileName( i ).c_str() ) );
			//<-------------------
			//2007/5/23 1.03----->
			ptarget = new ConvertTargetFile();
			path = m_fileDlg.GetFileName( i );

			if (musicTemp.Open( path, false ) == false) {
				ptarget->SetPath( path );
				ptarget->SetIdentifier( 0 );
				ptarget->SetSongTitle( L"???" );
			}
			else {
				O2JamMusicDesc desc = musicTemp.GetDescription();
				ptarget->SetPath( path );
				ptarget->SetIdentifier( desc.GetIdentifier() );
				ptarget->SetSongTitle( desc.GetTitle() );
			}

			wstringstream ss;
			ss.width( 4 );
			ss.fill( L'0' );
			ss << ptarget->GetIdentifier();
			ss << L" - ";
			ss << ptarget->GetSongTitle();
			ss << L" - (";
			ss << Utility::GetFileNameFromPath( ptarget->GetPath() );
			ss << L")";
			result = ::SendMessage( hwnd, LB_ADDSTRING, 0, reinterpret_cast<LPARAM>( ss.str().c_str() ) );
			::SendMessage( hwnd, LB_SETITEMDATA, result, reinterpret_cast<LPARAM>( ptarget ) );

			musicTemp.Close();
			//<-------------------
		}

		::EnableWindow( this->GetItem( IDC_MAIN_BUTTON_DELETE ), TRUE );
		::EnableWindow( this->GetItem( IDC_MAIN_BUTTON_START ), TRUE );
	}

	void MainDialog::OnDeleteTarget() {
		HWND hwnd = this->GetItem( IDC_MAIN_LIST );
		int index;
		//2007/5/23 1.03----->
		LRESULT result;
		//<-------------------

		while (::SendMessage( hwnd, LB_GETSELCOUNT, 0, 0 ) > 0) {
			::SendMessage( hwnd, LB_GETSELITEMS, 1, reinterpret_cast<LPARAM>( &index ) );

			//2007/5/23 1.03----->
			result = ::SendMessage( hwnd, LB_GETITEMDATA, index, 0 );
			if (result != LB_ERR && result != NULL) {
				delete reinterpret_cast<ConvertTargetFile*>( result );
			}
			//<-------------------

			::SendMessage( hwnd, LB_DELETESTRING, index, 0 );
		}

		if (::SendMessage( hwnd, LB_GETCOUNT, 0, 0 ) <= 0) {
			::EnableWindow( this->GetItem( IDC_MAIN_BUTTON_DELETE ), FALSE );
			::EnableWindow( this->GetItem( IDC_MAIN_BUTTON_START ), FALSE );
		}
	}

	void MainDialog::OnSelectOutDir() {
		if (m_dirDlg.Select() == false) {
			return;
		}
		else {
			::SetWindowText( this->GetItem( IDC_MAIN_EDIT_OUTDIR ), m_dirDlg.GetSelectedDirectory().c_str() );
			m_dirDlg.SetInitialDir( m_dirDlg.GetSelectedDirectory() );
		}
	}

	//2007/6/10 1.04----->
//	void MainDialog::OnCheckDecodeWav() {
//		if (::IsDlgButtonChecked( m_hwnd, IDC_MAIN_CHECK_WAVEOUT ) == BST_CHECKED) {
//			::EnableWindow( this->GetItem( IDC_MAIN_COMBO_QUALITY ), TRUE );
//		}
//		else {
//			::EnableWindow( this->GetItem( IDC_MAIN_COMBO_QUALITY ), FALSE );
//		}
//	}
	//<-------------------

	//2007/6/10 1.04----->
	void MainDialog::OnUpdateOfficialRule() {
		bool official = true;
		wchar_t buffer[256];

		//08/4/20 1.05----->
		if (::SendMessage( this->GetItem( IDC_MAIN_COMBO_DIFFICULTY ), CB_GETCURSEL, 0, 0 ) != O2JamDifficulty) {
			official = false;
		}
		//<-----------------

		::GetWindowText( this->GetItem( IDC_MAIN_EDIT_MAXLEVEL ), buffer, sizeof(buffer) );
		if (wcscmp( buffer, L"99" ) != 0) {
			official = false;
		}

		::GetWindowText( this->GetItem( IDC_MAIN_EDIT_O2MAXLEVEL ), buffer, sizeof(buffer) );
		if (wcscmp( buffer, L"99" ) != 0) {
			official = false;
		}

		if (::SendMessage( this->GetItem( IDC_MAIN_COMBO_JUDGE ), CB_GETCURSEL, 0, 0 ) != 0) {
			official = false;
		}

		if (::IsDlgButtonChecked( this->GetHandle(), IDC_MAIN_CHECK_LN2NN ) != BST_UNCHECKED) {
			official = false;
		}

		if (official == false) {
			::SetWindowText( this->GetItem( IDC_MAIN_STATIC_OFFICIAL ), L"" );
		}
		else {
			::SetWindowText( this->GetItem( IDC_MAIN_STATIC_OFFICIAL ), Resource::GetString( IDS_OFFICIALRULE ).c_str() );
		}
	}
	//<-------------------

	void MainDialog::OnStartConvert() {
		wstring appName = Resource::GetString( IDS_APPNAME );
		UINT mbStyle = MB_OK | MB_ICONEXCLAMATION;
		HWND hwnd;
		int i;
		int targetCount;
		//2007/5/23 1.03----->
		LRESULT target;
//		wchar_t target[MAX_PATH * 2];
		//<-------------------
		wchar_t outputDir[MAX_PATH];
		wchar_t maxLevelBuf[20];
		int maxLevel;
		//2007/5/20 1.02----->
		int maxLevelO2;
		//<-------------------
		SoundFormat format = SoundFormat::Wave;
		WaveQualities quality = MiddleWaveQuality;
		//08/4/20 1.05----->
		DifficultyTypes diffType;
		//<-----------------
		JudgeRanks judgeRank = NormalJudgement;
		bool outputEasy;
		bool outputNormal;
		bool outputHard;
		bool limitedSoundCount;
		//2007/2/24 1.01----->
		bool nothingLongNote;
		//<-------------------
		//2007/5/24 1.03----->
		bool dirExistsAbort;
		//<-------------------
		ConvertingDialog convertDlg;
		ResultDialog resultDlg;

		targetCount = ::SendMessage( this->GetItem( IDC_MAIN_LIST ), LB_GETCOUNT, 0, 0 );
		if (targetCount <= 0) {
			::MessageBox( m_hwnd, Resource::GetString( IDS_CHKERR_NOTARGET ).c_str(), appName.c_str(), mbStyle );
			::SetFocus( this->GetItem( IDC_MAIN_BUTTON_ADD ) );
			return;
		}

		::GetWindowText( this->GetItem( IDC_MAIN_EDIT_OUTDIR ), outputDir, sizeof(outputDir) );
		if (wcslen( outputDir ) == 0) {
			::MessageBox( m_hwnd, Resource::GetString( IDS_CHKERR_NOOUTDIR ).c_str(), appName.c_str(), mbStyle );
			::SetFocus( this->GetItem( IDC_MAIN_BUTTON_SELDIR ) );
			return;
		}

		::GetWindowText( this->GetItem( IDC_MAIN_EDIT_MAXLEVEL ), maxLevelBuf, sizeof(maxLevelBuf) );
		maxLevel = wcstol( maxLevelBuf, NULL, 10 );
		if (maxLevel <= 0) {
			::MessageBox( m_hwnd, Resource::GetString( IDS_CHKERR_MAXLEVEL ).c_str(), appName.c_str(), mbStyle );
			hwnd = this->GetItem( IDC_MAIN_EDIT_MAXLEVEL );
			::SetFocus( hwnd );
			::SendMessage( hwnd, EM_SETSEL, 0, ::GetWindowTextLength( hwnd ) );
			return;
		}

		//2007/5/20 1.02----->
		::GetWindowText( this->GetItem( IDC_MAIN_EDIT_O2MAXLEVEL ), maxLevelBuf, sizeof(maxLevelBuf) );
		maxLevelO2 = wcstol( maxLevelBuf, NULL, 10 );
		if (maxLevelO2 <= 0) {
			::MessageBox( m_hwnd, Resource::GetString( IDS_CHKERR_MAXLEVEL ).c_str(), appName.c_str(), mbStyle );
			hwnd = this->GetItem( IDC_MAIN_EDIT_O2MAXLEVEL );
			::SetFocus( hwnd );
			::SendMessage( hwnd, EM_SETSEL, 0, ::GetWindowTextLength( hwnd ) );
			return;
		}
		//<-------------------

		//2007/6/10 1.04----->
//		if (::IsDlgButtonChecked( m_hwnd, IDC_MAIN_CHECK_WAVEOUT ) == BST_UNCHECKED) {
//			format = SoundFormat::OggVorbis;
//		}
//		else {
//			format = SoundFormat::Wave;
//			switch (::SendMessage( this->GetItem( IDC_MAIN_COMBO_QUALITY ), CB_GETCURSEL, 0, 0 )) {
//				case 0: quality = LowWaveQuality; break;
//				case 1: quality = MiddleWaveQuality; break;
//				case 2: quality = HighWaveQuality; break;
//			}
//		}
		switch (::SendMessage( this->GetItem( IDC_MAIN_COMBO_QUALITY ), CB_GETCURSEL, 0, 0 )) {
			case 0:
				format = SoundFormat::Wave;
				quality = LowWaveQuality;
				break;
			case 1:
				format = SoundFormat::Wave;
				quality = MiddleWaveQuality;
				break;
			case 2:
				format = SoundFormat::Wave;
				quality = HighWaveQuality;
				break;
			case 3:
				format = SoundFormat::Wave;
				quality = OriginalWaveQuality;
				break;
//			case 4:
//				format = SoundFormat::OggVorbis;
//				quality = LowWaveQuality;
//				break;
			case 4:
				format = SoundFormat::OggVorbis;
				quality = MiddleWaveQuality;
				break;
			case 5:
				format = SoundFormat::OggVorbis;
				quality = HighWaveQuality;
				break;
			case 6:
				format = SoundFormat::OggVorbis;
				quality = OriginalWaveQuality;
				break;
		}
		//<-------------------

		//08/4/20 1.05----->
		diffType = static_cast<DifficultyTypes>( ::SendMessage( this->GetItem( IDC_MAIN_COMBO_DIFFICULTY ), CB_GETCURSEL, 0, 0 ) );
		//<-----------------

		switch (::SendMessage( this->GetItem( IDC_MAIN_COMBO_JUDGE ), CB_GETCURSEL, 0, 0 )) {
			case 0: judgeRank = EasyJudgement; break;
			case 1: judgeRank = NormalJudgement; break;
			case 2: judgeRank = HardJudgement; break;
			case 3: judgeRank = VeryHardJudgement; break;
		}

		outputEasy = (::IsDlgButtonChecked( m_hwnd, IDC_MAIN_CHECK_EASY ) == BST_CHECKED);
		outputNormal = (::IsDlgButtonChecked( m_hwnd, IDC_MAIN_CHECK_NORMAL ) == BST_CHECKED);
		outputHard = (::IsDlgButtonChecked( m_hwnd, IDC_MAIN_CHECK_HARD ) == BST_CHECKED);
		if (outputEasy == false && outputNormal == false && outputHard == false) {
			::MessageBox( m_hwnd, Resource::GetString( IDS_CHKERR_NOSCORE ).c_str(), appName.c_str(), mbStyle );
			::SetFocus( this->GetItem( IDC_MAIN_CHECK_EASY ) );
			return;
		}

		limitedSoundCount = (::IsDlgButtonChecked( m_hwnd, IDC_MAIN_CHECK_LIMSNDCNT ) == BST_CHECKED);
		//2007/2/24 1.01----->
		nothingLongNote = (::IsDlgButtonChecked( m_hwnd, IDC_MAIN_CHECK_LN2NN ) == BST_CHECKED);
		//<-------------------
		//2007/5/24 1.03----->
		dirExistsAbort = (::IsDlgButtonChecked( m_hwnd, IDC_MAIN_CHECK_DIREXISTS ) == BST_CHECKED);
		//<-------------------

		for (i = 0; i < targetCount; i++) {
			//2007/5/23 1.03----->
//			target[0] = L'\0';
//			::SendMessage( this->GetItem( IDC_MAIN_LIST ), LB_GETTEXT, i, reinterpret_cast<LPARAM>( target ) );
//			convertDlg.AddTarget( target );
			target = ::SendMessage( this->GetItem( IDC_MAIN_LIST ), LB_GETITEMDATA, i, 0 );
			if (target != LB_ERR && target != NULL) {
				convertDlg.AddTarget( *reinterpret_cast<ConvertTargetFile*>( target ) );
			}
			//<-------------------
		}
		convertDlg.SetOutputDir( outputDir );
		convertDlg.SetSoundFormat( format );
		convertDlg.SetWaveQualitiy( quality );
		//08/4/20 1.05----->
		convertDlg.SetDifficultyType( diffType );
		//<-----------------
		convertDlg.SetMaxLevel( maxLevel );
		//2007/5/20 1.02----->
		convertDlg.SetO2MaxLevel( maxLevelO2 );
		//<-------------------
		convertDlg.SetJudgeRank( judgeRank );
		convertDlg.SetOutputEasy( outputEasy );
		convertDlg.SetOutputNormal( outputNormal );
		convertDlg.SetOutputHard( outputHard );
		convertDlg.SetLimitedSoundCount( limitedSoundCount );
		//2007/2/24 1.01----->
		convertDlg.SetNothingLongNote( nothingLongNote );
		//<-------------------
		//2007/5/24 1.03----->
		convertDlg.SetDirExistsAbort( dirExistsAbort );
		//<-------------------
		convertDlg.Run( m_hwnd );

		targetCount = convertDlg.GetTargetCount();
		for (i = 0; i < targetCount; i++) {
			resultDlg.AddResult( convertDlg.GetTarget( i ), convertDlg.GetConvertResult( i ) );
		}

		resultDlg.Run( m_hwnd );

		::SetFocus( this->GetItem( IDC_MAIN_LIST ) );
	}
}
}