#pragma once

namespace Lmt {
namespace O2Bms {
	class ModalDialog {
	protected:
		HWND m_hwnd;
	private:
		int m_id;
	public:
		ModalDialog( int id );
		HWND GetHandle() const;
		HWND GetItem( int id ) const;
		int Run( HWND parent );
		LRESULT SendMsg( UINT msg, WPARAM wp, LPARAM lp ) const;
		LRESULT PostMsg( UINT msg, WPARAM wp, LPARAM lp ) const;
	protected:
		static LRESULT CALLBACK DialogProcBase( HWND hwnd, UINT msg, WPARAM wp, LPARAM lp );
		virtual bool DialogProc( UINT msg, WPARAM wp, LPARAM lp );
		virtual void OnInitDialog();
		virtual bool OnOk();
		virtual bool OnCancel();
		virtual bool OnCommand( WORD id, WORD code, HWND hwnd );
	};
}
}
