#pragma once
#include "SeekOrigin.hpp"

namespace Lmt {
namespace O2Bms {
	typedef unsigned long long score_t;
	class MusicPackage;

	class MusicPackageStream {
		friend class MusicPackage;
	private:
		//vTCY52oCg
		struct ItemHeader {
			char         Name[32];    //f[^̖O
			int          Length;      //f[^̃oCg
			int          BitRate;     //OggVorbis̃rbg[g
			unsigned int Flags;       //tO
			int          Identifier;  //f[^̎ʎq
			int          PcmLength;   //f[^PCMɂ̃oCg
		};
	private:
		static const unsigned int IsBgmFlag = 0x80000000;  //̃rbgĂ鎞BGM
	private:
		//08/4/20 1.05----->
//		static char m_xor[4];
		static const char m_nami[4];
		static const char m_noenc[4];
		//<-----------------
		ItemHeader m_header;
		int m_rank;
		int m_basePosition;
		int m_nowPosition;
		fstream *m_pfs;
		//08/4/20 1.05----->
		const char *m_pxor;
		//<-----------------
	public:
		//08/4/20 1.05----->
//		MusicPackageStream( fstream *pfs );
		MusicPackageStream( fstream *pfs, bool decrypt );
		//<-----------------
		bool Available() const;
		score_t GetSoundScore() const;
		wstring GetName() const;
		int GetLength() const;
		int GetIdentifier() const;
		int GetRank() const;
		int GetPcmLength() const;
		bool IsBackgroundMusic() const;
		int Read( void *pbuffer, int length );
		int Seek( int offset, SeekOrigin origin );
		int Tell() const;
		bool operator >( const MusicPackageStream &stream ) const;
	};
}
}
