#include "stdafx.h"
#include "O2JamMusic.hpp"
#include "Utility.hpp"

namespace Lmt {
namespace O2Bms {
	//2007/5/23 1.03----->
	DataTable O2JamMusic::m_titles;
	//<-------------------

	O2JamMusic::O2JamMusic() {
		m_opened = false;
	}
	
	O2JamMusic::~O2JamMusic() {
		this->Close();
	}
	
	O2JamMusicDesc O2JamMusic::GetDescription() const {
		return m_desc;
	}
	
	wstring O2JamMusic::GetEasyScorePath() const {
		return m_easyScorePath;
	}
	
	wstring O2JamMusic::GetNormalScorePath() const {
		return m_normalScorePath;
	}
	
	wstring O2JamMusic::GetHardScorePath() const {
		return m_hardScorePath;
	}
	
	wstring O2JamMusic::GetSongImagePath() const {
		return m_songImagePath;
	}
	
	wstring O2JamMusic::GetThumbnailPath() const {
		return m_thumbnailPath;
	}
	
	wstring O2JamMusic::GetMusicFilePath() const {
		return m_musicFilePath;
	}
	
	bool O2JamMusic::IsOpen() const {
		return m_opened;
	}
	
	//2007/5/23 1.03----->
//	bool O2JamMusic::Open( const wstring &path ) {
	bool O2JamMusic::Open( const wstring &path, bool loadResource ) {
	//<-------------------
		if (this->IsOpen() == true) {
			return false;
		}
		
		fstream fs( Utility::WStringToString( path ).c_str(), ios::in | ios::binary );
		OjnHeader hdr;
		O2JamMusicDesc desc;
		wstring easyScorePath;
		wstring normalScorePath;
		wstring hardScorePath;
		wstring songImagePath;
		wstring thumbnailPath;
		wstring musicFilePath;
		
		if (fs.is_open() == false) {
			goto ErrorMethod;
		}
		
		fs.read( (char*)&hdr, sizeof(hdr) );
		if (fs.gcount() != sizeof(hdr)) {
			goto ErrorMethod;
		}
		
		if (O2JamMusic::CheckHeader( hdr ) == false) {
			goto ErrorMethod;
		}

		::StrTrimA( hdr.Title, " " );
		::StrTrimA( hdr.Composer, " " );
		::StrTrimA( hdr.Maker, " " );
		
		desc.m_identifier = hdr.Identifier;
		desc.m_genre = O2JamMusic::MakeGenre( hdr.GenreID );
		//2007/5/23 1.03----->
//		desc.m_title = Utility::StringToWString( hdr.Title );
		//<-------------------
		desc.m_composer = Utility::StringToWString( hdr.Composer );
		desc.m_scoreMaker = Utility::StringToWString( hdr.Maker );
		desc.m_initialBPM = hdr.BPM;
		desc.m_easyLevel = hdr.EasyLevel;
		desc.m_normalLevel = hdr.NormalLevel;
		desc.m_hardLevel = hdr.HardLevel;

		//2007/5/23 1.03----->
		if (m_titles.GetTitle( desc.m_identifier, desc.m_title ) == false) {
			desc.m_title = Utility::StringToWString( hdr.Title );
		}
		//<-------------------
		
		//2007/5/23 1.03----->
		if (loadResource == true) {
		//<-------------------
			easyScorePath = O2JamMusic::CreateNewFile( fs, hdr.EasyNotePos, hdr.NormalNotePos - hdr.EasyNotePos );
			if (easyScorePath.length() == 0) {
				goto ErrorMethod;
			}
			
			normalScorePath = O2JamMusic::CreateNewFile( fs, hdr.NormalNotePos, hdr.HardNotePos - hdr.NormalNotePos );
			if (normalScorePath.length() == 0) {
				goto ErrorMethod;
			}
			
			hardScorePath = O2JamMusic::CreateNewFile( fs, hdr.HardNotePos, hdr.JpegPos - hdr.HardNotePos );
			if (hardScorePath.length() == 0) {
				goto ErrorMethod;
			}
			
			songImagePath = O2JamMusic::CreateNewFile( fs, hdr.JpegPos, hdr.JpegLength );
			if (songImagePath.length() == 0) {
				goto ErrorMethod;
			}
			
			thumbnailPath = O2JamMusic::CreateNewFile( fs, hdr.JpegPos + hdr.JpegLength, hdr.BitmapLength );
			if (thumbnailPath.length() == 0) {
				goto ErrorMethod;
			}
		//2007/5/23 1.03----->
		}
		//<-------------------
		
		musicFilePath = Utility::StringToWString( hdr.MusicFile );
		
		m_desc = desc;
		m_easyScorePath = easyScorePath;
		m_normalScorePath = normalScorePath;
		m_hardScorePath = hardScorePath;
		m_songImagePath = songImagePath;
		m_musicFilePath = musicFilePath;
		m_opened = true;
		//2007/5/23 1.03----->
		m_loadedResource = loadResource;
		//<-------------------
		return true;
		
	ErrorMethod:
		if (easyScorePath.length() > 0) {
			::DeleteFile( easyScorePath.c_str() );
		}
		if (normalScorePath.length() > 0) {
			::DeleteFile( normalScorePath.c_str() );
		}
		if (hardScorePath.length() > 0) {
			::DeleteFile( hardScorePath.c_str() );
		}
		if (songImagePath.length() > 0) {
			::DeleteFile( songImagePath.c_str() );
		}
		if (thumbnailPath.length() > 0) {
			::DeleteFile( thumbnailPath.c_str() );
		}
		return false;
	}
	
	void O2JamMusic::Close() {
		if (this->IsOpen() == true) {
			//2007/5/23 1.03----->
			if (m_loadedResource == true) {
			//<-------------------
				::DeleteFile( m_easyScorePath.c_str() );
				::DeleteFile( m_normalScorePath.c_str() );
				::DeleteFile( m_hardScorePath.c_str() );
				::DeleteFile( m_songImagePath.c_str() );
				::DeleteFile( m_thumbnailPath.c_str() );
			//2007/5/23 1.03----->
			}
			//<-------------------
			
			m_desc = O2JamMusicDesc();
			m_easyScorePath = L"";
			m_normalScorePath = L"";
			m_hardScorePath = L"";
			m_songImagePath = L"";
			m_thumbnailPath = L"";
			m_musicFilePath = L"";
			m_opened = false;
			//2007/5/23 1.03----->
			m_loadedResource = false;
			//<-------------------
		}
	}

	//2007/5/23 1.03----->
	DataTable * O2JamMusic::GetTitleTable() {
		return &m_titles;
	}
	//<-------------------
	
	bool O2JamMusic::CheckHeader( OjnHeader &h ) {
		if (h.Identifier < 0) {
			return false;
		}
		if (memcmp( h.Signature, "ojn\0", 4 ) != 0) {
			return false;
		}
		if (h.BPM < 1.0f) {
			return false;
		}
		//2007/5/24 1.03----->
		//Tl[݂̑ȂyȂ݂BTl[͎gpĂȂ̂
		//ȂĂȃt@CƂĔF悤ɂB
//		if (h.BitmapLength < 1) {
//			return false;
//		}
		//<-------------------
		if (h.Title[0] == 0) {
			return false;
		}
		if (h.Composer[0] == 0) {
			return false;
		}
		if (h.Maker[0] == 0) {
			return false;
		}
		if (h.MusicFile[0] == 0) {
			return false;
		}
		if (h.JpegLength < 1) {
			return false;
		}
		if (h.EasyNotePos > h.NormalNotePos) {
			return false;
		}
		if (h.NormalNotePos > h.HardNotePos) {
			return false;
		}
		if (h.HardNotePos > h.JpegPos) {
			return false;
		}
		
		h.Title[sizeof(h.Title) - 1] = '\0';
		h.Composer[sizeof(h.Composer) - 1] = '\0';
		h.Maker[sizeof(h.Maker) - 1] = '\0';
		h.MusicFile[sizeof(h.MusicFile) - 1] = '\0';
		return true;
	}
	
	wstring O2JamMusic::CreateNewFile( fstream &fs, int position, int length ) {
		fstream fsOut;
		int desireLength;
		string tempFileComp;
		wchar_t tempPath[MAX_PATH];
		wchar_t tempFile[MAX_PATH];
		char buffer[4096];
		
		::GetTempPath( sizeof(tempPath) / 2, tempPath );
		if (::GetTempFileName( tempPath, L"o2b", 0, tempFile ) == -1) {
			return L"";
		}
		
		tempFileComp = Utility::WStringToString( tempFile );
		fsOut.open( tempFileComp.c_str(), ios::out | ios::binary );
		if (fsOut.is_open() == false) {
			goto ErrorMethod;
		}
		
		fs.seekg( position, ios::beg );
		while (length > 0) {
			desireLength = min( sizeof(buffer), length );

			fs.read( buffer, desireLength );
			if (fs.gcount() == 0) {
				break;
			}
			
			fsOut.write( buffer, fs.gcount() );
			if (fsOut.fail()) {
				goto ErrorMethod;
			}

			length -= fs.gcount();
		}
		
		fsOut.close();
		return wstring( tempFile );
		
	ErrorMethod:
		if (fsOut.is_open() == true) {
			fsOut.close();
		}
		
		::DeleteFile( tempFile );
		return L"";
	}

	wstring O2JamMusic::MakeGenre( int genre ) {
		switch (genre) {
			case 1: return L"Rock";
			case 2: return L"Dance";
			case 3: return L"Techno";
			case 4: return L"Hip-hop";
			case 5: return L"Soul/R&B";
			case 6: return L"Jazz";
			case 7: return L"Funk";
			case 8: return L"Classical";
			case 9: return L"Traditional";
			case 10: return L"Etc";
			default: return L"Unknown";
		}
	}
}
}
