#pragma once
#include "O2JamNoteMeasure.hpp"
#include "O2JamNoteValues.hpp"

namespace Lmt {
namespace O2Bms {
	class O2JamNote {
		typedef map<int,O2JamNoteMeasure> MeasureMap;
		typedef map<float,int> TempoMap;
		typedef map<int,int> SoundMap;
		TempoMap m_tempos;
		SoundMap m_sounds;
		MeasureMap m_tempo;
		MeasureMap m_playable;
		MeasureMap m_background;
		int m_minMeasure;
		int m_maxMeasure;
	public:
		O2JamNote();
		const O2JamNoteMeasure * GetTempoMeasure( int measure ) const;
		const O2JamNoteMeasure * GetPlayableMeasure( int measure ) const;
		const O2JamNoteMeasure * GetBackgroundMeasure( int measure ) const;
		int GetMinMeasure() const;
		int GetMaxMeasure() const;
		int GetTempoCount() const;
		int GetTempoIdentifier( float tempo ) const;
		void GetTempoData( float *ptempos, int *pids ) const;
		int GetSoundCount() const;
		int GetSoundIdentifier( int sound ) const;
		void GetSoundData( int *psounds, int *pids ) const;
		bool Add( int measure, const O2JamNoteValues &values );
		void Clear();
		void BestCondition();
	};
}
}
