#pragma once

namespace Lmt {
namespace O2Bms {
	class PcmConverter {
		bool m_init;
		HACMSTREAM m_acm;
		WAVEFORMATEX m_wfIn;
		WAVEFORMATEX m_wfOut;
		int m_inSamples;
		int m_inBits;
		int m_inChannels;
		int m_outSamples;
		int m_outBits;
		int m_outChannels;
	public:
		PcmConverter();
		~PcmConverter();
		int GetInputSamples() const;
		int GetInputBits() const;
		int GetInputChannels() const;
		int GetOutputSamples() const;
		int GetOutputBits() const;
		int GetOutputChannels() const;
		WAVEFORMATEX GetInputWaveFormat() const;
		WAVEFORMATEX GetOutputWaveFormat() const;
		bool Initialize( int inSamples, int inBits, int inChannels, int outSamples, int outBits, int outChannels );
		bool Convert( const void *psrc, int srcLength, int *psrcUsed, void *pdest, int destLength, int *pdestUsed );
	private:
		bool NeedConvert() const;
		static bool TestSamples( int samples );
		static bool TestBits( int bits );
		static bool TestChannels( int channels );
	};
}
}
